Imports DongleControllerLib
Imports System.IO

Public Class Form1

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim setup As New DongleControllerLib.SetupDongle
        Dim pub() As Byte
        pub = setup.GenerateKey()
        Dim priv() As Byte
        priv = setup.PrivateKey

        Dim pub_file As New FileStream("public.key", FileMode.Create)
        pub_file.Write(pub, 0, pub.Length)
        pub_file.Close()

        Dim priv_file As New FileStream("private.key", FileMode.Create)
        priv_file.Write(priv, 0, priv.Length)
        priv_file.Close()
    End Sub

    Private Function read_file(ByVal name As System.String)
        Dim file As New FileStream(name, FileMode.Open)
        Dim len = file.Length
        Dim ret(len - 1) As Byte
        Dim read = 0
        While (read <> len)
            read += file.Read(ret, read, len - read)
        End While
        file.Close()
        read_file = ret
    End Function

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim sign As New SetupDongleClass()
        sign.PrivateKey = read_file("private.key")
        sign.SignDongle()
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Dim verify As New UseDongleClass()
        Dim publ() As Byte
        publ = read_file("public.key")
        If (verify.VerifyDongle(publ)) Then
            MessageBox.Show("Validation successful")
        Else
            MessageBox.Show("Validation failed")
        End If
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Dim sign As New SetupDongleClass()
        sign.PrivateKey = read_file("private.key")
        sign.SignDonglePassword(TextBox1.Text)
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        Dim verify As New UseDongleClass()
        If (verify.VerifyDonglePassword(read_file("public.key"), TextBox1.Text)) Then
            MessageBox.Show("Validation successful")
        Else
            MessageBox.Show("Validation failed")
        End If
    End Sub
End Class
